#include <entry.h>
#include "../treeprinter/treeprinter.h"
#include <iostream>

using namespace std;

/**
 * Module test 1.
 * Used to verify that the Tree printer it writes out every Verilog module that the AST contains.
 */
int main()
{
  /** Construct a root entry, this should be empty */
  Entry *root = new Entry;
  //  root->extends = 0; tobbe: should be

  Entry *file = new Entry;
  file->section = Entry::SOURCE_SEC; // Set entry type
  file->name = "smurf.v";            // Set entry name
  file->fileName = "smurf.v";        // File this entry was found in
  file->bodyLine = file->startLine = 1; // Line # of entry
  file->parent = root;               // Set parent
  root->addSubEntry(file);           // Add to (the same) parent

  Entry *module = new Entry;
  module->section = Entry::MODULE_SEC;
  module->name = "some_file";
  module->fileName = "some_file.v";        // File this entry was found in
  module->bodyLine = module->startLine = 3; // Line # of entry
  module->parent = root;               // Set parent
  root->addSubEntry(module);           // Add to (the same) parent

  module = new Entry;
  module->section = Entry::MODULE_SEC;
  module->name = "another_file";
  module->fileName = "weee.v";        // File this entry was found in
  module->bodyLine = module->startLine = 3; // Line # of entry
  module->parent = root;               // Set parent
  root->addSubEntry(module);           // Add to (the same) parent

  module = new Entry;
  module->section = Entry::MODULE_SEC;
  module->name = "yeoldparrot";
  module->fileName = "yaaarrrr.v";        // File this entry was found in
  module->bodyLine = module->startLine = 3; // Line # of entry
  module->parent = root;               // Set parent
  root->addSubEntry(module);           // Add to (the same) parent

  TreePrinter tp(true);
  tp.print(cout, root);
  //  cout << TreePrinter(root);
}
