//Reg, input, output och parameter som vektorer.


module uarttx(din,load,clock,reset,shift,txd,ready,CS);
    input [7:0] din;		//data to be transmitted
    input load;			//loads the transmit register
    input clock;			// 1x transmit clock
    input reset; 			// resets the registers
    input shift;			// this is when the shift register is supposed to shift
    output txd;			// output data
    output ready;			// indicates ready to recieve char to transmit
	output [3:0]CS;		//state output

	reg ready;			//ready status bit
	reg txd;				//transmit bit

     reg [8:0] INT;		//nine bit shift register
	reg [7:0] Hold;	//holding register for the data
	reg doshift;		//tells the shift register to shift its data
	reg doload;		//tells the shift register to load its data
	reg clearready;	//tells the ready bit to clear
	reg setready;		//tells the ready bit to set
			
parameter [3:0] //synopsys enum STATE_TYPE
    UART_IDLE = 4'b0000,
    UART_STARTBIT = 4'b0001,
    UART_BIT7 = 4'b0010,
    UART_BIT6 = 4'b0011,
    UART_BIT5 = 4'b0100,
    UART_BIT4 = 4'b0101,
    UART_BIT3 = 4'b0110,
    UART_BIT2 = 4'b0111,
    UART_BIT1 = 4'b1000,
    UART_BIT0 = 4'b1001,
    UART_STOPBIT = 4'b1010;
 

endmodule
