#include <entry.h>
#include "../treeprinter/treeprinter.h"
#include <iostream>

using namespace std;

/**
 * This is an example of how to construct a tree manually
 * for testing purposes.
 */
int main()
{
  /** Construct a root entry, this should be empty */
  Entry *root = new Entry;
  //  root->extends = 0; tobbe: should be

  Entry *file = new Entry;
  file->section = Entry::SOURCE_SEC; // Set entry type
  file->name = "smurf.v";            // Set entry name
  file->fileName = "smurf.v";        // File this entry was found in
  file->bodyLine = file->startLine = 1; // Line # of entry
  file->parent = root;               // Set parent
  root->addSubEntry(file);           // Add to (the same) parent

  /* tobbe tried to add argument ... but failed :(
  Argument* arg = new Argument;
  arg->name = "test argument";
  arg->docs = "my documentation ...\n...kommer hr :)";
  root->addArgument(arg);
  */

  Entry *module = new Entry;
  module->section = Entry::MODULE_SEC;
  module->doc = "my documentation ...\n...kommer hr :)";;
  module->name = "gammelsmurfen";
  module->fileName = "smurf.v";        // File this entry was found in
  module->bodyLine = module->startLine = 3; // Line # of entry
  module->parent = root;               // Set parent
  root->addSubEntry(module);           // Add to (the same) parent

  Entry *node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  node->name = "wb_we_i";
  node->fileName = "smurf.v";        // File this entry was found in
  node->bodyLine = node->startLine = 7; // Line # of entry
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent

  node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  node->name = "wb_we_iIIIII";
  node->fileName = "gammelsmurfen.v";        // File this entry was found in
  node->bodyLine = node->startLine = 7; // Line # of entry
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent
  
  module = new Entry;
  module->section = Entry::MODULE_SEC;
  module->name = "smurf2";
  module->fileName = "smurf.v";        // File this entry was found in
  module->bodyLine = module->startLine = 3; // Line # of entry
  module->parent = root;               // Set parent
  root->addSubEntry(module);           // Add to (the same) parent
  
  node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  node->name = "wb_we_i";
  node->fileName = "smurf.v";        // File this entry was found in
  node->bodyLine = node->startLine = 7; // Line # of entry
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent

  node = new Entry;
  node->protection = Private;
  node->section = 666;//Entry::VARIABLE_SEC;
  node->name = "wb_a_i";
  node->args = "[31:0]";             // Set range
  node->fileName = "smurf.v";        // File this entry was found in
  node->bodyLine = node->startLine = 8; // Line # of entry
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent

  TreePrinter tp(true);
  tp.print(cout, root);
  //  cout << TreePrinter(root);
}
