#include <entry.h>
#include "../treeprinter/treeprinter.h"
#include <iostream>

using namespace std;

/**
 * Module test 4.
 * Used to verify that the Tree printer writes out every wire that the AST contains.
 */
int main()
{
  /** Construct a root entry, this should be empty */
  Entry *e0 = new Entry;

  Entry *e1 = new Entry;
  e1->name = "0001";
  e0->addSubEntry(e1);

  Entry *e2 = new Entry;
  e2->name = "0002";
  e1->addSubEntry(e2);

  Entry *e3 = new Entry;
  e3->name = "0003";
  e2->addSubEntry(e3);

  Entry *e4 = new Entry;
  e4->name = "0004";
  e3->addSubEntry(e4);

  Entry *e5 = new Entry;
  e5->name = "0005";
  e4->addSubEntry(e5);

  Entry *e6 = new Entry;
  e6->name = "0006";
  e5->addSubEntry(e6);

  Entry *e7 = new Entry;
  e7->name = "0007";
  e6->addSubEntry(e7);

  Entry *e8 = new Entry;
  e8->name = "0008";
  e7->addSubEntry(e8);

  Entry *e9 = new Entry;
  e9->name = "0009";
  e8->addSubEntry(e9);

  Entry *ea = new Entry;
  ea->name = "000a";
  e9->addSubEntry(ea);

  Entry *eb = new Entry;
  eb->name = "000b";
  ea->addSubEntry(eb);

  Entry *ec = new Entry;
  ec->name = "000c";
  eb->addSubEntry(ec);

  cout << "Printing a tree!" << endl;
  TreePrinter tp(false,  11);
  tp.print(cout, e0);
}
